<template>
    <div v-if="listItem.length" class="autocomplete">
        <div class="autocomplete__list" @mousedown.stop="selectItem"
             @keyup="nextItem">
            <div v-for="(item, index) in listItem"
                 :key="`${item}-${index}`"
                 :id="'item' + `-${index}`"
                 :class="['autocomplete__list-item', { 'is-selected': index === key }]"
            >{{ item }}</div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'base-autocomplete',
    props: {
        url: {
            type: String
        },
        value: {
            required: true
        },
        minLength: {
            type: Number,
            default: 3
        }
    },
    data() {
        return {
            listItem: [],
            key: null
        };
    },
    watch: {
        value() {
            const self = this;
            if (this.value && this.value.length >= this.minLength) {
                axios.get(this.url, {
                    params: {
                        query: this.value
                    }
                })
                    .then(response => {
                        const { data } = response;
                        if (data.length === 1 && data[0] === this.value) {
                            self.listItem = [];
                            return self.listItem;
                        } else {
                            self.listItem = data;
                            return self.listItem;
                        }
                    })
                    .catch(error => {
                        console.error(error);
                    });
            }
        }
    },
    methods: {
        selectItem(e) {
            this.$emit('selected', e.target.innerText);
        },
        escItem() {
            this.listItem = [];
        },
        previousItem() {
            if (this.key !== null) {
                this.key === 0 ? this.key = 0 : this.key--;
            }
        },
        nextItem() {
            this.key === null ? this.key = 0 : (this.key >= this.listItem.length - 1) ? this.key = this.listItem.length - 1 : this.key++;
        },
        enterItem(e) {
            e.preventDefault();
            if (this.key !== null) {
                this.$emit('selected', this.listItem[this.key]);
                this.key = null;
            }
        }
    }
};
</script>

<style lang="sass">
    @import '~blocks/autocomplete';
    .autocomplete__list-item.is-selected
        background-color: #164873
</style>
